<template>
  <input-base :name="name" :size="size" :error="error">
    <font-awesome-icon class="icon" v-if="icon != null" :icon="icon" />
    <input
      class="input"
      :type="type"
      :value="modelValue"
      v-on:input.stop="on_input"
    />
  </input-base>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { IconDefinition } from "@fortawesome/free-solid-svg-icons";

import InputBase from "@/components/input/InputBase.vue";

@Options({
  props: {
    modelValue: {
      type: String,
      requierd: true,
    },
    type: {
      type: String,
      default: "text",
    },
    name: {
      type: String,
      requierd: false,
    },
    size: {
      type: Number,
      requierd: false,
    },
    error: {
      type: String,
      requierd: false,
    },
    icon: {
      type: Object,
      requierd: false,
    },
  },
  emits: ["update:modelValue"],
  components: {
    FontAwesomeIcon,
    InputBase,
  },
})
export default class InputTextField extends Vue {
  public modelValue!: string;
  public type!: string;

  public name?: string;
  public error?: string;
  public size?: number;
  public icon?: IconDefinition;

  public on_input(event: any): void {
    this.$emit("update:modelValue", event.target.value);
  }
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";
.icon {
  padding: $small_spacing;
  padding-right: 0;
}

.input {
  padding: $small_spacing;
  margin: 0;
  display: block;

  border: none;
  outline: none;
  flex-grow: 1;

  font-size: 16px;

  box-sizing: border-box;
}
</style>
